##
# Konstante
##
GORE, DOLE, DESNO = 1, 2, 3 # konstante

class Slog:
	def __init__(self, a, b):
		self.zbir = a
		self.put  = b
	def __cmp__(self, drugi):
		if isinstance(drugi, Slog): # da li je drugi obj. instanca klase Slog
			if self.zbir == drugi.zbir: return 0 # jednaki su
			if self.zbir > drugi.zbir: return 1  # tekuci obj. je >
		return -1 # tekuci je < ili drugi obj. nije klase Slog (npr. None)
	def __str__(self):
		return 'zbir = %d, put = %s' % (self.zbir, self.put)
 ###### -- Slog


# daje 1 od objekata sa min zbirom, pri tom objekti b i c ne moraju da postoje
# tj. oni mogu biti None. Ovde se implicitno zove redefinisana metoda __cmp__
def min(a, b, c):
	if a <= b: 
		m = a
	else:
		m = b
	if m > c: m = c
	return m
############### -- MIN()	

# rekurzivno trazi put sa min. zbirom za dati red (ako se prosledi 
# indeks pocetnog elementa reda). Vraca objekat tipa Slog
def s(tabela,red, kol, smer):
	n = len(tabela)
	gore, dole = None, None
	
	if red == n or red == -1: # prekoracenje gornje ili donje granice tabele
		return None
	
	if kol == n - 1: # stigo do kranje kolone
		return Slog(tabela[red][kol], '[%d,%d] = %d' % (red, kol, tabela[red][kol]))
	
	desno = s(tabela,red, kol + 1, DESNO)
	
	# ne vracaj se odakle si dosao i ne idi gore i dole ako si u pocetnoj koloni
	if smer != GORE and kol != 0: 
		dole =  s(tabela, red + 1, kol, DOLE)
	if smer != DOLE and kol != 0:
		gore =  s(tabela, red - 1, kol, GORE)
	
	m = min(desno, gore, dole)
	
	# dodavanje vrednosti i putanje tekuceg cvora na vrednst i putanju prethodnih
	m.zbir += tabela[red][kol]
	m.put = '[%d,%d] = %d -> ' % (red, kol, tabela[red][kol]) + m.put
	return m
############### -- S()

def mat(tabela):
	n = len(tabela)
	# uradi s() nad svakim redom
	lista = []
	for i in range(n):
		lista.append(s(tabela,i, 0, DESNO))
	print '\nKontrolni pregled liste:'
	for i in range(len(lista)):
		print 'red', i, '\n', lista[i]
	print '####'
	# nadji najmanju putanju iz liste 
	najmanji = lista[0]
	print 'red', 0, '\n', lista[0]
	for i in range(1, n):
		print i
		print 'red', i, '\n', lista[i]
		if lista[i].zbir < najmanji.zbir:
			najmanji = lista[i]
			print 'najmanji:\n', najmanji	
	return najmanji
########### -- MAT()

########### MAIN
tab = [[1,5,9,8], [0,0,9,9], [2,1,0,9], [5,6,0,0]]
print 'tabela', tab
print '\nKonacni rezultat je \n%s' % mat(tab)

